'******************************************************************************
' Copyright (c) 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

OBJ
  ser : "FullDuplexSerial"

DAT
  teststr byte "This is a test string.  The quick brown fox jumps over the lazy dog.", 13, 0

PUB main

  ser.start(31, 30, 0, 1_000_000)
  waitcnt(clkfreq*3+cnt)

  RunTest(@teststr)
  RunTest(@license)

PUB RunTest(ptr) | len, start, stop

  len := strsize(ptr)

  start := cnt
  ser.txblock(ptr, len)
  stop := cnt
  ser.dec(len)
  ser.str(string(" bytes sent in "))
  ser.dec((stop - start)/(clkfreq/1000000))
  ser.str(string(" usec -- "))
  ser.dec(len*10*(clkfreq/(stop - start)))
  ser.str(string(" baud", 13))
  
DAT
license byte
  byte "+-----------------------------------------------------------------------------+", 13
  byte "|                       TERMS OF USE: MIT License                             |", 13
  byte "+-----------------------------------------------------------------------------+", 13
  byte "|Permission is hereby granted, free of charge, to any person obtaining a copy |", 13
  byte "|of this software and associated documentation files (the 'Software'), to deal|", 13
  byte "|in the Software without restriction, including without limitation the rights |", 13
  byte "|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |", 13
  byte "|copies of the Software, and to permit persons to whom the Software is        |", 13
  byte "|furnished to do so, subject to the following conditions:                     |", 13
  byte "|                                                                             |", 13
  byte "|The above copyright notice and this permission notice shall be included in   |", 13
  byte "|all copies or substantial portions of the Software.                          |", 13
  byte "|                                                                             |", 13
  byte "|THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |", 13
  byte "|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |", 13
  byte "|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |", 13
  byte "|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |", 13
  byte "|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|", 13
  byte "|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|", 13
  byte "|SOFTWARE.                                                                    |", 13
  byte "+-----------------------------------------------------------------------------+", 13
  byte 0